SystemOrganization addCategory: #'PharoBot-Core'!

Workspace subclass: #PharoBotWorkspaceModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoBot-Core'!

Object subclass: #PharoBotEnvironment
	instanceVariableNames: 'workspaces'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoBot-Core'!

!PharoBotEnvironment commentStamp: 'NahuelGarbezza 4/7/2012 17:49' prior: 0!
Contiene configuraciones basicas para iniciar un entorno de PharoBot, como por ejemplo los workspaces.!

!PharoBotEnvironment methodsFor: 'actions' stamp: 'NahuelGarbezza 4/7/2012 17:31'!
addWorkspace: aWorkspace

	self workspaces add: aWorkspace! !

!PharoBotEnvironment methodsFor: 'constants' stamp: 'NahuelGarbezza 4/7/2012 17:32'!
defaultVariableBindings

	^{}! !

!PharoBotEnvironment methodsFor: 'initialize-release' stamp: 'NahuelGarbezza 4/7/2012 17:31'!
initialize

	workspaces := OrderedCollection with: self startWorkspace.! !

!PharoBotEnvironment methodsFor: 'actions' stamp: 'NahuelGarbezza 4/7/2012 17:31'!
removeWorkspace: aWorkspace

	self workspaces remove: aWorkspace! !

!PharoBotEnvironment methodsFor: 'constants' stamp: 'NahuelGarbezza 4/8/2012 12:21'!
robotClass

	^Robot! !

!PharoBotEnvironment methodsFor: 'constants' stamp: 'NahuelGarbezza 4/8/2012 12:21'!
robotMethods

	"Reemplazar por los metodos de la clase Robot que se quieran mostrar"
	^self robotClass selectors! !

!PharoBotEnvironment methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/8/2012 09:16'!
workspaces

	^workspaces! !

PharoBotEnvironment subclass: #PharoBotEnvironmentWithClasses
	instanceVariableNames: 'classes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoBot-Core'!

!PharoBotEnvironmentWithClasses commentStamp: 'NahuelGarbezza 4/7/2012 17:49' prior: 0!
Extension a PharoBotEnvironment que permite manejar clases en el entorno.!

!PharoBotEnvironmentWithClasses methodsFor: 'actions' stamp: 'NahuelGarbezza 2/27/2012 11:08'!
addClass: aClass

	self classes add: aClass! !

!PharoBotEnvironmentWithClasses methodsFor: 'accessing' stamp: 'NahuelGarbezza 2/27/2012 11:12'!
classes

	^classes! !

!PharoBotEnvironmentWithClasses methodsFor: 'actions' stamp: 'NahuelGarbezza 2/27/2012 11:08'!
exportClassTo: aFileName
	
	self shouldBeImplemented.! !

!PharoBotEnvironmentWithClasses methodsFor: 'actions' stamp: 'NahuelGarbezza 2/27/2012 11:08'!
importClassFrom: aFileName
	
	self shouldBeImplemented.
	"Llamar a addClass:"! !

!PharoBotEnvironmentWithClasses methodsFor: 'initialize-release' stamp: 'NahuelGarbezza 2/27/2012 11:13'!
initialize

	super initialize.
	classes := OrderedCollection with: self robotClass! !

!PharoBotEnvironmentWithClasses methodsFor: 'actions' stamp: 'NahuelGarbezza 2/27/2012 11:08'!
removeClass: aClass

	self classes remove: aClass! !

!PharoBotEnvironmentWithClasses methodsFor: 'accessing' stamp: 'NahuelGarbezza 2/27/2012 11:14'!
startWorkspace

	^PharoBotWorkspace new
		title: 'Bienvenido a PharoBot - Clase 2';
		content:'"Bienvenido a PharoBot - Clase 2"';
		variableBindings: self defaultVariableBindings asDictionary;
		yourself! !

PharoBotEnvironment subclass: #PharoBotEnvironmentWithObjects
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoBot-Core'!

!PharoBotEnvironmentWithObjects methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/7/2012 17:50'!
defaultVariableBindings

	^{ #robotech -> self robotClass new }! !

!PharoBotEnvironmentWithObjects methodsFor: 'constants' stamp: 'NahuelGarbezza 2/27/2012 11:14'!
startWorkspace

	^PharoBotWorkspace new
		title: 'Bienvenido a PharoBot - Clase 1';
		content:
'
"Bienvenido a PharoBot - Clase 1"

robotech mover: 100.
robotech norte.

etc, etc, etc...
';
	variableBindings: self defaultVariableBindings asDictionary;
	yourself! !

Object subclass: #PharoBotWorkspace
	instanceVariableNames: 'title content variableBindings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoBot-Core'!

!PharoBotWorkspace methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/7/2012 17:29'!
content

	^content! !

!PharoBotWorkspace methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/7/2012 17:29'!
content: anObject

	content := anObject! !

!PharoBotWorkspace methodsFor: 'initialize-release' stamp: 'NahuelGarbezza 2/11/2012 17:08'!
initialize

	variableBindings := Dictionary new.! !

!PharoBotWorkspace methodsFor: 'printing' stamp: 'NahuelGarbezza 2/11/2012 17:04'!
printOn: aStream

	aStream << self title! !

!PharoBotWorkspace methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/7/2012 17:29'!
title

	^title! !

!PharoBotWorkspace methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/7/2012 17:29'!
title: anObject

	title := anObject! !

!PharoBotWorkspace methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/7/2012 17:29'!
variableBindings

	^variableBindings! !

!PharoBotWorkspace methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/7/2012 17:29'!
variableBindings: anObject

	variableBindings := anObject! !

Object subclass: #Robot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoBot-Core'!
